﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using System.Collections.ObjectModel;

using Infragistics.Windows.DataPresenter;

using IGViewModel;

using System.ComponentModel;

namespace XamDataPresenter_Grid
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            BindingList<Car> carList = new BindingList<Car>();
            carList.Add(new Car("Dodge", "Ram", 22050.00, 153));
            carList.Add(new Car("Ford", "Explorer", 27175.00, 96));
            carList.Add(new Car("BMW", "Z4", 35600.00, 42));
            carList.Add(new Car("Toyota", "Camry", 20790.99, 131));

            this.XamDataPresenter1.DataSource = carList;
        }

        public Record flag;
        

        private void XamDataPresenter1_RecordAdded(object sender, Infragistics.Windows.DataPresenter.Events.RecordAddedEventArgs e)
        {
            flag = e.Record;
        }

        ////This option works.  Uncomment it and comment out below to see that this option works.
        //private void XamDataPresenter1_RecordUpdated(object sender, Infragistics.Windows.DataPresenter.Events.RecordUpdatedEventArgs e)
        //{
        //    if (e.Record == flag)
        //    {
        //        XamDataPresenter dp = sender as XamDataPresenter;
        //        Dispatcher.BeginInvoke(new Action(() =>
        //        {

        //            dp.ActiveRecord.RecordManager.CurrentAddRecord.Cells[0].IsActive = true;

        //            dp.ExecuteCommand(DataPresenterCommands.StartEditMode);

        //        }), System.Windows.Threading.DispatcherPriority.Background, null);


        //    }
        //}

        private void XamDataPresenter1_RecordUpdated(object sender, Infragistics.Windows.DataPresenter.Events.RecordUpdatedEventArgs e)
        {
            //this option does not ever start edit mode!!  Comment out and uncomment above to see that it works.
            if (e.Record == flag)
            {
                XamDataPresenter dp = sender as XamDataPresenter;

                e.Record.RecordManager.CurrentAddRecord.Cells[0].IsActive = true;

                dp.ExecuteCommand(DataPresenterCommands.StartEditMode);

                flag = null;

            }

        }



        
    }
}
